package cpcns.danganzhengli.zhuanTi.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganzhengli.zhuanTi.model.DZhuanTi;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.utils.StringUtil;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

@Controller
@RequestMapping({"/dzhuanTi"})
public class zhuanTiController extends commonController {
  @Autowired
  private ICommonService commonService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request, HttpServletResponse response) throws Exception {
    String type = getRequest().getParameter("type");
    getRequest().setAttribute("type", type);
    return "danganzhengli/zhuanTi/zhuanTi_List";
  }
  
  @RequestMapping({"/toadd.do"})
  public String toadd(HttpServletRequest request, HttpServletResponse response) throws Exception {
    String type = getRequest().getParameter("type");
    getRequest().setAttribute("type", type);
    return "danganzhengli/zhuanTi/zhuanTi_List";
  }
  
  @RequestMapping({"/getAll"})
  @ResponseBody
  public String getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    JSONObject jsonObject = new JSONObject();
    JSONObject childrenjsonObject = new JSONObject();
    PagerVO pagevo = new PagerVO();
    List<Map<String, String>> list = new ArrayList<>();
    StringBuffer sqlWhere = new StringBuffer();
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    String type = request.getParameter("type");
    StringBuffer sqlSearch = new StringBuffer();
    sqlSearch.append(" 1=1 ");
    sqlSearch.append(" and zhuangTai not in(3,4)");
    sqlSearch.append(" and type ='" + type + "'");
    sqlSearch.append(" or  hangbiaoshi =4");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    sqlWhere.append(" select hangBiaoShi,dangHao,biaoTi,xuHao,timeBegin,timeEnd,jieDianCengCi,shuXing,yuanWenLuJing,parentId,zhuangTai,iconCls,state,youYuanWen,wenJianGeShi from D_zhuanTiWenJian where");
    pagevo = this.commonService.getAll(start, number, sqlWhere.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "shuxing,parentid,xuHao asc"), "D_zhuanTiWenJian");
    String treegrid_data2 = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    treegrid_data2 = treegrid_data2.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("BIAOTI", "biaoTi").replaceAll("DANGHAO", "dangHao")
      .replaceAll("XUHAO", "xuHao").replaceAll("TIMEBEGIN", "timeBegin").replaceAll("TIMEEND", "timeEnd")
      .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("JIEDIANCENGCI", "jieDianCengCi").replaceAll("SHUXING", "shuXing").replaceAll("YOUYUANWEN", "youYuanWen")
      .replaceAll("YUANWENLUJING", "yuanWenLuJing").replaceAll("PARENTID", "_parentId").replaceAll("ICONCLS", "iconCls").replaceAll("STATE", "state").replaceAll("WENJIANGESHI", "wenJianGeShi");
    write(response, treegrid_data2);
    return "";
  }
  
  @RequestMapping({"/append.do"})
  public String append(HttpServletRequest request, Model model) throws Exception {
    String parentId = request.getParameter("hangBiaoShi");
    String type = request.getParameter("type");
    DZhuanTi zt = new DZhuanTi();
    zt.setParentId(parentId);
    zt.setType(type);
    model.addAttribute("DZhuanTi", zt);
    return "danganzhengli/zhuanTi/zhuanTi_edit";
  }
  
  @RequestMapping({"/appendYuanWen.do"})
  public String appendYuanWen(HttpServletRequest request, Model model) throws Exception {
    String parentId = request.getParameter("hangBiaoShi");
    model.addAttribute("hangBiaoShi", parentId);
    return "danganzhengli/zhuanTi/zhuanTi_Importt";
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, Model model) throws Exception {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (hangBiaoShi != null && !hangBiaoShi.equals("")) {
      StringBuffer sqlWhere = new StringBuffer();
      sqlWhere.append("  from DZhuanTi where  hangBiaoShi =" + hangBiaoShi);
      DZhuanTi zt = new DZhuanTi();
      List<DZhuanTi> list = this.commonService.getListHQL(sqlWhere.toString());
      for (DZhuanTi zts : list)
        zt = zts; 
      model.addAttribute("DZhuanTi", zt);
    } 
    return "danganzhengli/zhuanTi/zhuanTi_edit";
  }
  
  @RequestMapping({"/save.do"})
  @ResponseBody
  public void saveFJ(@RequestParam(value = "upload", required = false) MultipartFile[] upload, HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    DZhuanTi t = (DZhuanTi)JsonWithJacksonUtils.getInstance().json2Obj(jsonObject.toString(), DZhuanTi.class);
    String xtlx = AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING");
    Map<String, String> map1 = new HashMap<>();
    map1.put("table", this.table);
    map1.put("server", this.server);
    if (t.getHangBiaoShi() != null && t.getHangBiaoShi().intValue() > 0)
      map1.put("hangBiaoShi_not", String.valueOf(t.getHangBiaoShi())); 
    if (t != null) {
      if (t.getHangBiaoShi() == null || t.getHangBiaoShi().equals("")) {
        int hangBiaoShi = this.commonService.getPk("D_ZhuanTiWenJian");
        t.setHangBiaoShi(Integer.valueOf(hangBiaoShi));
        t.setYouYuanWen(Integer.valueOf(0));
        t.setZhuangTai(Integer.valueOf(1));
      } else {
        t.setZhuangTai(Integer.valueOf(1));
      } 
      try {
        if (upload != null && upload.length > 0) {
          String xdLuJing = getPath("D_ZhuanTiWenJian", getCurrentUser().getQuanZongHao(), String.valueOf(t.getHangBiaoShi()));
          String CPCNS_CUNCHUFANGSHI = AppConfiguration.getConfigValue("CPCNS_CUNCHUFANGSHI");
          String path = StringUtil.dealBasePath(AppConfiguration.getConfigValue("DangAnYuanWenPath"));
          for (int i = 0; i < upload.length; i++) {
            MultipartFile files = upload[i];
            String yuanWenJianName = files.getOriginalFilename();
            String geshi = StringUtils.substringAfterLast(yuanWenJianName, ".");
            if (StringUtils.isNotBlank(yuanWenJianName)) {
              Boolean fileExitFlag = Boolean.valueOf(false);
              File file = new File(String.valueOf(path) + File.separator + xdLuJing + t.getHangBiaoShi() + "." + geshi);
              if (!file.exists()) {
                file.mkdirs();
                fileExitFlag = Boolean.valueOf(true);
              } else {
                fileExitFlag = Boolean.valueOf(true);
              } 
              files.transferTo(file);
              t.setYuanWenLuJing(xdLuJing);
              t.setYouYuanWen(Integer.valueOf(1));
              t.setYuanWenJianMing(yuanWenJianName);
              t.setWenJianGeShi(geshi);
            } 
          } 
        } 
        this.commonService.saveOrUpdate(t);
        rm.setSuccess(true);
        rm.addResultMessage("hangBiaoShi", t.getHangBiaoShi());
        info = "保存成功！";
      } catch (Exception e) {
        e.printStackTrace();
        info = "保存失败！";
        rm.setSuccess(false);
      } 
      rm.setInfo(info);
      responseWriter(response, rm.toString());
    } else {
      info = "数据转换错误！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  protected String getPath(String table, String quanZong, String hangBiaoShi) {
    if (StringUtils.isBlank(quanZong))
      quanZong = "001"; 
    String path = "ZTWJ" + File.separator + quanZong + File.separator + hangBiaoShi + File.separator;
    path = FuJianPathUtils.dealBasePath(path);
    return path;
  }
  
  @RequestMapping({"/yuLan.do"})
  public String yuLan(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String filePath = "";
    if (StringUtils.isNotBlank(hangBiaoShi))
      try {
        StringBuffer sql = new StringBuffer();
        sql.append("  from DZhuanTi where  hangBiaoShi =" + hangBiaoShi);
        DZhuanTi zt = new DZhuanTi();
        List<DZhuanTi> list = this.commonService.getListHQL(sql.toString());
        for (DZhuanTi zts : list)
          zt = zts; 
        String bcsf = AppConfiguration.getConfigValue("CPCNS_CUNCHUFANGSHI");
        String DianZiDangAnManager = AppConfiguration.getConfigValue("DianZiDangAnManager");
        String DianZiDangAnCiPanLuJing = AppConfiguration.getConfigValue("DianZiDangAnCiPanLuJing");
        String path = StringUtil.dealBasePath(AppConfiguration.getConfigValue("DangAnYuanWenPath"));
        filePath = StringUtil.dealBasePath(String.valueOf(DianZiDangAnManager) + DianZiDangAnCiPanLuJing + "/" + zt.getYuanWenLuJing() + zt.getHangBiaoShi() + "." + zt.getWenJianGeShi());
      } catch (Exception e) {
        e.printStackTrace();
      }  
    request.setAttribute("filePath", filePath);
    return "danganzhengli/zhuanTi/zhuanTi_check";
  }
  
  @RequestMapping({"/uploadFuJian.do"})
  @ResponseBody
  public void uploadFuJian(HttpServletRequest request, HttpServletResponse response) throws IOException {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      StringBuffer sql = new StringBuffer();
      sql.append("  from DZhuanTi where  hangBiaoShi =" + hangBiaoShi);
      DZhuanTi zt = new DZhuanTi();
      List<DZhuanTi> list = this.commonService.getListHQL(sql.toString());
      for (DZhuanTi zts : list)
        zt = zts; 
      String CPCNS_CUNCHUFANGSHI = AppConfiguration.getConfigValue("CPCNS_CUNCHUFANGSHI");
      String DianZiDangAnManager = AppConfiguration.getConfigValue("DianZiDangAnManager");
      String DianZiDangAnCiPanLuJing = AppConfiguration.getConfigValue("DianZiDangAnCiPanLuJing");
      String path = StringUtil.dealBasePath(AppConfiguration.getConfigValue("DangAnYuanWenPath"));
      String fuJianPath = StringUtil.dealBasePath(String.valueOf(path) + "/" + zt.getYuanWenLuJing());
      boolean fileis = false;
      fuJianPath = StringUtil.dealBasePath(String.valueOf(fuJianPath) + zt.getHangBiaoShi() + "." + zt.getWenJianGeShi());
      File file = new File(fuJianPath);
      if (file.exists()) {
        String encodeName = new String(zt.getYuanWenJianMing().getBytes("GB2312"), "ISO8859_1");
        response.setCharacterEncoding("utf-8");
        response.setHeader("content-disposition", "attachment;filename=" + encodeName);
        FileInputStream fis = new FileInputStream(file);
        ServletOutputStream servletOutputStream = response.getOutputStream();
        byte[] buffer = new byte[1024];
        int len = 0;
        while ((len = fis.read(buffer)) > 0)
          servletOutputStream.write(buffer, 0, len); 
        fis.close();
        servletOutputStream.close();
        if (fileis)
          file.delete(); 
      } 
    } 
  }
  
  @RequestMapping({"/deleteAll.do"})
  @ResponseBody
  public void deleteAll(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String parentID = request.getParameter("parentID");
    String tablename = "D_zhuanTiWenJian";
    StringBuffer sql = new StringBuffer();
    String info = "";
    String CPCNS_CUNCHUFANGSHI = AppConfiguration.getConfigValue("CPCNS_CUNCHUFANGSHI");
    String DianZiDangAnManager = AppConfiguration.getConfigValue("DianZiDangAnManager");
    String DianZiDangAnCiPanLuJing = AppConfiguration.getConfigValue("DianZiDangAnCiPanLuJing");
    String path = StringUtil.dealBasePath(AppConfiguration.getConfigValue("DangAnYuanWenPath"));
    String server = request.getParameter("server");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      try {
        sql.append("update D_zhuanTiWenJian set zhuangTai =3 where hangBiaoShi in (" + hangBiaoShi + ")");
        DZhuanTi zt = new DZhuanTi();
        StringBuffer sqlbf = new StringBuffer();
        sqlbf.append("  from DZhuanTi where  hangBiaoShi =" + hangBiaoShi);
        List<DZhuanTi> list = this.commonService.getListHQL(sqlbf.toString());
        for (DZhuanTi zts : list)
          zt = zts; 
        this.commonService.deleteBySql(sql.toString());
        rm.setSuccess(true);
        info = "删除成功！";
        this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_zhuanTiWenJian", Integer.valueOf(Integer.parseInt(hangBiaoShi)), String.valueOf(zt.getBiaoTi()) + "$." + zt.getHangBiaoShi() + "$." + "ZTWJ", "删除");
      } catch (Exception e) {
        e.printStackTrace();
        rm.setSuccess(false);
        info = "删除失败！";
      } 
      rm.setInfo(info);
      rm.addResultMessage("data", "[{}]");
      responseWriter(response, rm.toString());
    } else if (StringUtils.isNotBlank(parentID)) {
      try {
        sql.append("update D_zhuanTiWenJian set zhuangTai=3 where hangBiaoShi in (" + parentID + ")");
        StringBuffer ptsql = new StringBuffer("  from DZhuanTi where  hangBiaoShi in (" + parentID + ")");
        StringBuffer hql = new StringBuffer();
        DZhuanTi pt = new DZhuanTi();
        List<DZhuanTi> ptlists = this.commonService.getListHQL(ptsql.toString());
        for (DZhuanTi zts : ptlists)
          pt = zts; 
        StringBuffer sqlbf = new StringBuffer();
        sqlbf.append("  from DZhuanTi where  parentID in (" + parentID + ")");
        List<DZhuanTi> list = this.commonService.getListHQL(sqlbf.toString());
        String fuJianPath = "";
        boolean is = false;
        if (list.size() > 0)
          for (int a = 0; a < list.size(); a++) {
            DZhuanTi zt = new DZhuanTi();
            is = false;
            zt = list.get(a);
            hql.append("update D_zhuanTiWenJian set zhuangTai =3 where hangBiaoShi in (" + zt.getHangBiaoShi() + ")");
            this.commonService.deleteBySql(hql.toString());
            this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_zhuanTiWenJian", Integer.valueOf(Integer.parseInt(zt.getHangBiaoShi().toString())), String.valueOf(zt.getBiaoTi()) + "$." + zt.getHangBiaoShi() + "$." + "ZTWJ", "删除");
          }  
        this.commonService.deleteBySql(sql.toString());
        rm.setSuccess(true);
        info = "删除成功！";
        this.commonService.addDA_RiZhi(getCurrentUser(), server, "D_zhuanTiWenJian", Integer.valueOf(Integer.parseInt(parentID)), String.valueOf(pt.getBiaoTi()) + "$." + pt.getHangBiaoShi() + "$." + "ZTWJ", "删除");
      } catch (Exception e) {
        e.printStackTrace();
        rm.setSuccess(false);
        info = "删除失败！";
      } 
      rm.setInfo(info);
      rm.addResultMessage("data", "[{}]");
      responseWriter(response, rm.toString());
    } 
    rm.setSuccess(false);
    rm.setInfo("删除失败，选择的记录无效！");
    responseWriter(response, rm.toString());
  }
}
